## START: Set by rpmautospec
## (rpmautospec version 0.2.6)
%define autorelease(e:s:pb:) %{?-p:0.}%{lua:
    release_number = 2;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{?dist}
## END: Set by rpmautospec

# F35: Do not update past 1.6.0. F35's protobuf is too old.

# tests are enabled by default
%bcond_without tests

%global         srcname     google-cloud-functions
%global         forgeurl    https://github.com/googleapis/python-functions
Version:        1.8.3
%global         tag         v%{version}
%forgemeta

Name:           python-%{srcname}
Release:        %autorelease
Summary:        Python Client for Google Cloud Functions

License:        ASL 2.0
URL:            %forgeurl
Source0:        %forgesource

BuildArch:      noarch

BuildRequires:  python3-devel

%if %{with tests}
BuildRequires:  python3dist(pytest)
BuildRequires:  python3dist(pytest-asyncio)
%endif

%global _description %{expand:
Manages lightweight user-provided functions executed in response to events
via the Google Cloud Functions API.}

%description %{_description}


%package -n python3-%{srcname}
Summary:        %{summary}
%description -n python3-%{srcname} %{_description}


%prep
%forgeautosetup

# Allow a slightly older protobuf.
sed -i 's/"protobuf.*",/"protobuf>=3.19.4",/' setup.py

# Replace mock imports with unittest.mock.
grep -rl "^[[:space:]]*import mock" tests | \
    xargs sed -i -E 's/^([[:space:]]*)import mock/\1from unittest import mock/'


%generate_buildrequires
%pyproject_buildrequires


%build
%pyproject_wheel


%install
%pyproject_install
%pyproject_save_files google

# Remove unneeded executable.
rm -f %{buildroot}/%{_bindir}/fixup_functions_v1_keywords.py


%check
%pyproject_check_import -e 'google.cloud.functions_v2*'

%if %{with tests}
# Work around an usual pytest/PEP 420 issue where pytest can't import the
# installed module. Thanks to mhroncok for the help!
mv google{,_}
%pytest --disable-warnings tests/unit
mv google{_,}
%endif


%files -n python3-%{srcname} -f %{pyproject_files}
%doc README.rst CHANGELOG.md
%{python3_sitelib}/google_cloud_functions-%{version}-py%{python3_version}-nspkg.pth


%changelog
* Wed Oct 19 2022 Major Hayden <major@redhat.com> 1.8.3-2
- Allow a slightly older protobuf version

* Wed Oct 19 2022 Major Hayden <major@redhat.com> 1.8.3-1
- Update to 1.8.3 rhbz#2131089

* Mon Aug 15 2022 Major Hayden <major@redhat.com> 1.8.1-1
- Update to 1.8.1 rhbz#2107287

* Wed Jul 27 2022 Major Hayden <major@redhat.com> 1.8.0-1
- Update to 1.8.0 rhbz#2107287

* Fri Jul 22 2022 Fedora Release Engineering <releng@fedoraproject.org> 1.7.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Tue Jun 28 2022 Python Maint <python-maint@redhat.com> 1.7.0-2
- Rebuilt for Python 3.11

* Mon Jun 13 2022 Major Hayden <major@redhat.com> 1.7.0-1
- Update to 1.7.0

* Thu Jun 02 2022 Major Hayden <major@redhat.com> 1.6.0-2
- Update spec to test import and use sed for mock imports

* Mon Apr 18 2022 Major Hayden <major@mhtx.net> 1.6.0-1
- Update to 1.6.0

* Tue Mar 08 2022 Major Hayden <major@redhat.com> 1.5.2-1
- Update to 1.5.2

* Tue Mar 01 2022 Major Hayden <major@redhat.com> 1.5.1-1
- Update to 1.5.1

* Wed Feb 09 2022 Major Hayden <major@redhat.com> 1.5.0-2
- Bump revision

* Fri Jan 28 2022 Major Hayden <major@redhat.com> 1.5.0-1
- Update to 1.5.0

* Fri Jan 21 2022 Fedora Release Engineering <releng@fedoraproject.org> 1.4.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Mon Nov 08 2021 Major Hayden <major@redhat.com> 1.4.0-1
- Update to 1.4.0

* Tue Nov 02 2021 Major Hayden <major@mhtx.net> 1.3.1-1
- Update to 1.3.1

* Mon Oct 25 2021 Major Hayden <major@mhtx.net> 1.3.0-1
- Update to 1.3.0

* Tue Oct 12 2021 Major Hayden <major@mhtx.net> 1.2.0-1
- Update to 1.2.0

* Thu Sep 30 2021 Major Hayden <major@mhtx.net> 1.1.1-1
- Update to 1.1.1

* Mon Sep 20 2021 Major Hayden <major@mhtx.net> 1.1.0-2
- Update sources to 1.1.0

* Mon Sep 20 2021 Major Hayden <major@mhtx.net> 1.1.0-1
- Update to 1.1.0

* Fri Sep 17 2021 Major Hayden <major@mhtx.net> 1.0.4-3
- Fix tests with PEP 420 workaround

* Thu Sep 09 2021 Major Hayden <major@mhtx.net> 1.0.4-2
- Move to rpmautospec

* Tue Aug 31 2021 Major Hayden <major@mhtx.net> 1.0.4-1
- Update to 1.0.4

* Tue Aug 24 2021 Major Hayden <major@mhtx.net> 1.0.3-1
- Initial import (#1996873)
